<?php

Class MoskitusForum 
{
	protected $forum_id;
	protected $encoding;
	protected $request_page = 'http://s1.moskitus.ru/get.ashx';
	
	protected $timeout 	= 30;
	protected $portion	= 2048;
	
	public function __construct($forum_id, $encoding)
	{
		if(!is_numeric($forum_id)) {
			return(false);
		}
		$this->forum_id = $forum_id;
		$this->encoding = $encoding;
	}
	
	public function GetHtml()
	{
		$url = parse_url($_SERVER['REQUEST_URI']);
		
		if (!isset($url['query'])) {
			$query = 'fid=' . $this->forum_id;
		}
		else {
			$query = $url['query'] . '&fid=' . $this->forum_id;
		}
		
		$query .= '&enc=' . $this->encoding;
		
		return($this->Request($query));
	}
	
	protected function Request($query)
	{
		$arr 	= parse_url($this->request_page);
		
	    $nn 	= "\r\n";
	    $host 	= $arr["host"];
	    $ref 	= $arr["scheme"] . "://" . $host;
	    $path 	= !empty($arr["path"]) ? $arr["path"] : '/';;
		
	    $path .= "?" . $query;
		
		$cookies = '';
		if (!empty($_COOKIE)) {
			foreach($_COOKIE as $key=>$value) {
				$cookies .= $key . '=' . $value . ';';
			}
		}
		
	    $request = 	"GET " . $path . " HTTP/1.1" . $nn .
					"Host: " . $host . $nn .
					"Connection: Close" . $nn .
					(!empty($cookies) ? "Cookie: " . $cookies . $nn : "") .
					$nn;
		
	    $fp = fsockopen($host, 80, &$errno, &$errstr, $this->timeout);
		
		if(!$fp) { print "$errstr ($errno)<br>\n"; exit; }
		
	    fwrite($fp, $request);
		
		$reply='';
		while (!feof($fp))
			$reply .= fgets($fp, $this->portion);
		fclose($fp);
		
		$e = preg_split('~(\r\n\r\n)|(\n\r\n\r)|(\n\n)|(\r\r)~', $reply, 2);
		
		$response_headers 	= $e[0];
		$response_body 		= isset($e[1]) ? $e[1] : '';
		
		$cookies = $this->GetCookies($response_headers);
		
		foreach ($cookies as $cook) {
			setcookie($cook['name'], $cook['value'], $cook['expire'], "/");
		}
		
		return($response_body);
	}
	
	protected function GetCookies($headers)
	{
		$arr = split("\r\n", $headers);
		$j = count($arr);

		$cookies = array();
		for($i=0; $i<($j-1); $i++) {
			if(ereg("^Set-Cookie:",$arr[$i])) {
				$a = array();
		        list($c, $time) = split(";", $arr[$i]);
		        list($trash, $c) = split( ":", $c);
		        list($cname, $c) = split( "=", $c, 2);
				$time = explode('=', $time);
				
				$a['name'] = trim($cname);
				$a['value'] = trim($c);
				$a['expire'] = strtotime(trim($time[1]));
				
				$cookies[] = $a;
			}
		}
		
		return($cookies);
	}
}

?>