<?php
/**
 * Zebrum Lite
 *
 * ЛИЦЕНЗИЯ
 *
 * Этот исходный файл является предметом лицензии, которая включена в данный
 * пакет в файле LICENSE.txt.
 * Она так же доступна через всемирную сеть Интернет по этому URL:
 * http://www.zebrum.ru/license.html
 *
 * @category   zebrum
 * @package    zengine
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 * @version    $Id: php.php 346 2008-09-24 06:17:22Z lks $
 */

/** zfilter */
require_once 'zengine/classes/zfilter.php';

/**
 * Реализация интерфейса фильтра. Интерпретирует содержимое страницы как
 * PHP-скрипт
 *
 * @package    zengine
 * @subpackage zfilter
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 */
class zfilter_php implements zfilter {
    /**
     * Проверяем текст на наличие ошибок и интерпретируем, если их нет и если
     * это не запрещено настройками системы
     *
     * @param string $text
     * @return string
     */
    public function filter ($text)
    {
        if (! zengine::config()->get('source.allowphp', false)) {
            return $text;
        }

        ob_start();
        eval('?>' . $text);
        $evaled = ob_get_contents();
        ob_end_clean();

        if (true == (bool) preg_match('/Parse error:\s*syntax error,(.+?)\s+in\s+.+?\s*line\s+(\d+)/', strip_tags($evaled), $matches)) {
            return '<p>Синтаксическая ошибка PHP в содержимом страницы на строчке ' . $matches[2] . ', ' . $matches[1] . '</p>';
        }

        return $evaled;
    }
}
