<?php
/**
 * Zebrum Lite
 *
 * ЛИЦЕНЗИЯ
 *
 * Этот исходный файл является предметом лицензии, которая включена в данный
 * пакет в файле LICENSE.txt.
 * Она так же доступна через всемирную сеть Интернет по этому URL:
 * http://www.zebrum.ru/license.html
 *
 * @category   zebrum
 * @package    zengine
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 * @version    $Id: zmodule.php 491 2008-11-11 14:13:37Z lks $
 */


/**
 * Абстрактный класс модуля
 *
 * @package    zengine
 * @subpackage zmodule
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 */
abstract class zmodule {
    /**
     * Возвращает объект страницы, которую нужно показать
     *
     * @param string $uri запрос к модулю
     * @return zpage
     */
    abstract public function getPage ($uri);

    /**
     * Устанавливает параметры модуля
     *
     * @param array $arParams
     */
    public function setParams (array $arParams) {
    	$this->_params = $arParams;
    }

    /**
     * Устанавливает отдельный параметр модуля
     *
     * @param string $key Название параметра
     * @param string $value Значение параметра
     */
    public function setParam ($key, $value) {
    	$this->_params[$key] = $value;
    }

    /**
     * Возвращает значение параметра модуля
     *
     * @param string $key Название параметра
     * @param mixed $default Значение по умолчанию, если параметр не задан
     * @return mixed
     */
    public function getParam ($key, $default = null) {
        if (isset($this->_params[$key])) {
            return $this->_params[$key];
        }

    	return $default;
    }

    /**
     * Массив параметров модуля
     *
     * @var array
     */
    protected $_params;
}
