<?php
/**
 * Zebrum Lite
 *
 * ЛИЦЕНЗИЯ
 *
 * Этот исходный файл является предметом лицензии, которая включена в данный
 * пакет в файле LICENSE.txt.
 * Она так же доступна через всемирную сеть Интернет по этому URL:
 * http://www.zebrum.ru/license.html
 *
 * @category   zebrum
 * @package    zengine
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 * @version    $Id: menu.php 493 2008-11-12 14:20:49Z lks $
 */


/**
 * Выводит меню сайта
 *
 * @package    zengine
 * @subpackage zhelper
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 */
class zhelper_menu {
    /**
     * Выводим меню. Возможные типы меню: expanded, minimal
     *
     * @param string $type Тип меню
     */
    public function menu ($type = 'expanded') {
        $this->nofollow = '';
        if (zengine::config()->get('menu.nofollow')) {
            $this->nofollow = ' rel="nofollow"';
        }
        $this->pagepath = $this->zpage->getPagepath();

        $this->type = $type;
        echo '<ul id="menu">';
        $this->displayItems(zengine::zsource()->getMenu());
        echo '</ul>';
    }

    /**
     * Выводим подпункты меню
     *
     * @param zmenu $items
     */
    private function displayItems ($items) {
        foreach ($items as $item) {
            if ($item->nomenuitem) {
                continue;
            }

            if ($this->pagepath == $item->uri) {
                echo '<li class="current">' . $item->name;
            } else {
                if (strpos($this->pagepath, $item->uri . '/') === 0 || strpos($item->uri, dirname($this->pagepath)) !== 0) {
                    echo '<li><a href="' . $item->link . '"' . $this->nofollow . '>' . $item->name . '</a>';
                } else {
                    echo '<li><a href="' . $item->link . '">' . $item->name . '</a>';
                }
            }
            if ($this->showSubmenu($item) && $item->hasSubmenu()) {
                echo '<ul>';
                $this->displayItems($item);
                echo '</ul>';
            }
            echo '</li>';
        }
    }

    /**
     * Метод проверяет, нужно ли выводить подпункты меню данного пункта
     *
     * @param zmenu $item пункт меню
     * @return boolean
     */
    private function showSubmenu ($item) {
    	if ($this->type == 'minimal') {
    	    if ($item->uri == $this->pagepath || strpos($this->pagepath, $item->uri . '/') === 0) {
    	       return true;
    	    } else {
    	        return false;
    	    }
    	}
    	return true;
    }

    /**
     * Тип меню, которое нужно вывести
     *
     * @var string
     */
    private $type;

    /**
     * Дополнительные атрибуты к пунктам меню
     *
     * @var string
     */
    private $nofollow;

    /**
     * Путь к текущей странице
     *
     * @var string
     */
    private $pagepath;
}
